/************************************************************/
/************************************************************/
/************************************************************/
class scan 
    {
       private:
            int   error_code;
            int   rest;
            int   number_primitives;
            int   comment_line;
            int   module_found;
            int   continuous_comment;
            char  module_name[line_length+1];
            char  instance_name[line_length+1];
            char  instance_source[line_length+1];
            char* module;
            char* connect_module;
            char* endmodule;
            char* broken_line;
            char* module_position;
            char* opening_comment;
            char* closing_comment;
            char* one_line_comment;
            char* comment_position;
            char* parenth_pointer;
            char* point_pointer;
            char* primitive;
            module_chain   * module_pointer;
            instance_chain * current_instance;
/**/
            enum anakateponymous
               {
                  max_numb_primitives = 256,
                  number_keywords     =  31
               };
            char* keywords[number_keywords];
            char* primitives[max_numb_primitives];
/**/
       public:
            scan()
               {
                  error_code         = 0;
                  rest               = 4;
                  number_primitives  = 0,
                  comment_line       = no;
                  module_found       = no;
                  continuous_comment = no;
                  module_name[0]     = terminator;
                  instance_name[0]   = terminator;
                  module             = "module";
                  connect_module     = "connectmodule";
                  endmodule          = "endmodule";
                  primitive          = "primitive";
                  broken_line        = NULL;
                  module_position    = NULL;
                  parenth_pointer    = NULL;
                  point_pointer      = NULL;
                  opening_comment    = "/*";
                  closing_comment    = "*/";
                  one_line_comment   = "//";
                  comment_position   = NULL;
                  module_pointer     = NULL;
                  current_instance   = NULL;
/**/
                  keywords[ 0] = "@";
                  keywords[ 1] = "$";
                  keywords[ 2] = "\"";
                  keywords[ 3] = "=";
                  keywords[ 4] = "always";
                  keywords[ 5] = "and";
                  keywords[ 6] = "buf";
                  keywords[ 7] = "case";
                  keywords[ 8] = "cmos";
                  keywords[ 9] = "for";
                  keywords[10] = "if";
                  keywords[11] = "nand";
                  keywords[12] = "nmos";
                  keywords[13] = "nor";
                  keywords[14] = "not";
                  keywords[15] = "notif";
                  keywords[16] = "or";
                  keywords[17] = "pmos";
                  keywords[18] = "pulldown";
                  keywords[19] = "pullup";
                  keywords[20] = "rcmos";
                  keywords[21] = "rnmos";
                  keywords[22] = "rpmos";
                  keywords[23] = "repeat";
                  keywords[24] = "rtran";
                  keywords[25] = "rtranif";
                  keywords[26] = "specify";
                  keywords[27] = "tran";
                  keywords[28] = "tranif";
                  keywords[29] = "xnor";
                  keywords[30] = "xor";
/**/
               };
            ~scan()
               {
// empty for now
               };
/*************************************************************/
int is_keyword(char line[])
   {                    // this is linear search,
      int count;        // no other way to do it.
      int found;
      char* pointer;
      count = (-1);
      found = no;
      while ((++count < number_keywords) && (found == no))
            if ((pointer = strstr(line,keywords[count])) != NULL)
               if (strcmp(keywords[count],"not") != 0)
                  found = yes;
               else;
            else;
      if ((found == yes) && (pointer != NULL))
         {
            pointer--;
            if (isalnum(*pointer))
               found = no;
            else;
         }
      else;
//cout << "keywords[count] is =" << keywords[count-1] << endl;
      return found;
  };  /*  is_keyword()  */
/*************************************************************/
int is_comment_line(char line[])
   {
/**/
     if ((strstr(line,one_line_comment) == NULL) &&
         (strstr(line,opening_comment) == NULL) &&
         (strstr(line,closing_comment) == NULL))
        if (continuous_comment == yes)
           comment_line = yes;
        else
           comment_line = no;
     else if (strncmp(line,one_line_comment,2) == 0)
        comment_line = yes;
     else
        if (continuous_comment == yes)
           {     //closing comment might be on line
              char* pointer;
              pointer = strchr(line,star);
              if (pointer != NULL)
                 {
                    pointer++;
                    if (is_slash(*pointer))
                       {
                          *pointer = terminator;
                          pointer++;
                          strcpy(line,pointer);
                          comment_line = no;
                          continuous_comment = no;
                       }
                    else;
                 }
              else;
           }
        else if (continuous_comment == no)
           {
              char *pointer;
              pointer = strchr(line,slash);
              pointer++;
              if (is_slash(*pointer))
                 {
                   pointer--;
                   pointer--;
                   *pointer = terminator;
                   if (strlen(line) <= rest)
                      comment_line = yes;
                   else
                      comment_line = no;
                 }
              else if (is_star(*pointer))
                 {
                    char *begin;
                    begin = pointer;
                    pointer++;
                    while ((!is_star(*pointer)) && 
                                   (!is_terminator(*pointer)))
                        pointer++;
                    if (is_terminator(*pointer))
                       { // /* comment starts here, ends on next lines
                          continuous_comment = yes;
                          begin--;
                          *begin = terminator;
                          if (strlen(line) <= rest)
                             comment_line = yes;
                          else
                             comment_line = no;
                       }
                    else if (is_star(*pointer))
                       {
                          pointer++;
//cout << "1     found what =" << pointer << endl;
                          if (is_slash(*pointer))
                             { // comment ends on same line
                                 begin--;
                                 *begin = terminator;
                                 strcat(line," ");
                                 pointer++;
                                 strcat(line,pointer);
                                 comment_line = no;
//cout << "reduced line is =" << line << endl;
                             }
                           else
                              ;  // code to be added here
                       }
                 }
              else  // code to be added here
                 ;
           }
        else;
/**/
//cout << "Entcommented line is =" << line << endl;
        return comment_line;
/**/
   };  /*  is_comment_line()  */
/*************************************************************/
int is_empty_line(char line[])
{
int count;
/**/
count = 0;
while ((isspace(line[count])) && (!is_terminator(line[count])))
      count++;
if (is_terminator(line[count]))
   return yes;
else
   return no;
/**/
};    /* is_empty_line()    */
/*************************************************************/
            void extract_module_name(char line[],
                                          char module_name[])
               {
                  char* name_end;
                  char* name_begin;
                  name_begin = strstr(line,module);
                  if (name_begin != NULL)//just to make sure
                     {
                        while (isalpha(*name_begin))
                            name_begin++; //skip word "module"
//cout << "Trying to find the module name =" << name_begin << endl;
                        while (isspace(*name_begin))
                            name_begin++; //skip space
//cout << "Trying to find the module name 22=" << name_begin << endl;
                        name_end = name_begin;
                        while (isalnum(*name_end) ||
                                          is_underscore(*name_end))
                            name_end++;
                        strncpy(module_name,name_begin,
                                    name_end-name_begin+1);
                        module_name[name_end-name_begin] =
                                    terminator;
//cout << "Extracted module name is =" << module_name << endl;
                     }
                  else; // disaster if it comes here
               };  /*  extract_module_name()  */
/*************************************************************/
            void insert_module_name(
                  file_chain* file_pointer,char module_name[])
               {
                  int   length;
                  char* string;
/**/
                  module_pointer = NULL; // just to make sure
                  if (file_pointer->module_header == NULL)
                     {    // first time we are here
                        module_pointer = new module_chain;
                        module_pointer->instance_header = NULL;
                        module_pointer->next            = NULL;
                        length = strlen(module_name);
                        string = new char [length+1];
                        strcpy(string,module_name);
                        module_pointer->module_name = string;
                        file_pointer->module_header = module_pointer;
                     }
                  else // more than one modules exist in the file
                     {
                        module_chain* previous;
                        module_pointer = file_pointer->module_header;
                        while (module_pointer != NULL)
                            {
                               previous = module_pointer;
                               module_pointer = module_pointer->next;
                            }
                        module_pointer = new module_chain;
                        module_pointer->instance_header = NULL;
                        module_pointer->next            = NULL;
                        length = strlen(module_name);
                        string = new char [length+1];
                        strcpy(string,module_name);
                        module_pointer->module_name = string;
                        previous->next = module_pointer;

                     }
/**/
               };  /* insert_module_name()   */
/*************************************************************/
int extract_instance_name(char line[], char instance_name[])
   {
       char* name_end;
       char* name_begin;
/**/
       name_end = strchr(line,opening_parenthesis);
       name_begin = name_end;
       name_begin--; // move left from the parenthesis
       while (isspace(*name_begin))
             name_begin--;
       name_end = name_begin;
       while ((isalnum(*name_begin)) || (is_underscore(*name_begin)))
             name_begin--;
       broken_line = name_begin;
       name_begin++; // catch 1st char of name
       strncpy(instance_name,name_begin,name_end-name_begin+1);
       instance_name[name_end-name_begin+1] = terminator;
/**/
//cout << "Extracted instance name is = " << instance_name << endl;
//cout << "Its length is = " << strlen(instance_name) << endl;
/**/
       return  strlen(instance_name);
/**/
               };  /* extract_instance_name()  */
/*************************************************************/
instance_chain* insert_instance_name(char instance_name[])
   {
//cout << "Instance name to be inserted =" << instance_name << endl;
      int length;
      char* string;
/**/
      length = strlen(instance_name);
      string = new char [length+1];
      strcpy(string,instance_name);
      current_instance->instance_name = string;
/**/
//cout << "Inserted instance name =" <<
//                   current_instance->instance_name << endl;
/**/
      return current_instance;
               };  /* insert_instance_name()  */
/*************************************************************/
            void bridge_the_gap(char line[])
               {
                   char * mark;
/**/
                   while (isspace(*broken_line))
                         broken_line--;
                   mark = broken_line;
                   if (isdigit(*broken_line))
                      {
                         while ((isdigit(*broken_line)) &&
                                    (broken_line != &line[0]))
                                broken_line--;
                         if (broken_line != &line[0])
                            if (is_sharp(*broken_line))
                               broken_line--;
                            else
                               broken_line = mark; // restore
                         else;  // disaster if it comes here
                      }
                   else
                      if (strchr(line,sharp) != NULL)
                         {
                            while (!(is_sharp(*broken_line)))
                                  broken_line--;
                            broken_line--;
                         }
                      else; // no action necessary
/**/
               };   /*  bridge_the_gap()   */
/*************************************************************/
int extract_instance_source(char* broken_line,
                           char line[],char instance_source[])
  {
     char* name_end;
/**/
     while (isspace(*broken_line))
          broken_line--;
     name_end = broken_line;
     while (((isalnum(*broken_line)) || (is_underscore(*broken_line)))
                                && (broken_line >= line))
         broken_line--;
     broken_line++;
     strncpy(instance_source,broken_line,name_end-broken_line+1);
     instance_source[name_end-broken_line+1] = terminator;
/**/
//cout << "Extracted instance source is =" << instance_source << endl;
/**/
     return strlen(instance_source);
/**/
  };  /*  extract_instance_source();
/*************************************************************/
void insert_instance_source(char instance_source[])
   {
     int   length;
     char* string;
/**/
     length = strlen(instance_source);
     string = new char [length+1];
     strcpy(string,instance_source);
     current_instance->instance_source = string;
/**/
  };  /*   insert_instance_source   */
/*************************************************************/
void insert(char instance_name[], char instance_source[],
                                module_chain* module_pointer)
  {
    if (module_pointer->instance_header == NULL)
       {        //first time we are here
         current_instance = new instance_chain;
         current_instance->next = NULL;
         insert_instance_name(instance_name);
         insert_instance_source(instance_source);
         module_pointer->instance_header = current_instance;
      }
   else       //more than one instantiations
      {       // within current module
         instance_chain* previous;
         current_instance = module_pointer->instance_header;
         while (current_instance != NULL)
             {
                previous = current_instance;
                current_instance = current_instance->next;
             }
         current_instance = new instance_chain;
         current_instance->next = NULL;
         insert_instance_name(instance_name);
         insert_instance_source(instance_source);
         previous->next = current_instance;
     }
   current_instance = NULL;//just to make sure
/**/
 };   /*  insert()   */
/*************************************************************/
int is_continuation_line(char line[])
   {
       if ((point_pointer = strchr(line,point)) == NULL)
          return no;
       else
          if (point_pointer < parenth_pointer)
             return yes;
          else
             return no;
   };   /*  is_continuation_line()   */
/*************************************************************/
int is_primitive(char primitive_name[])
   {
     int count;
/**/
     count = 0;
     while (count < number_primitives)
         if (strcmp(primitive_name,primitives[count]) == 0)
            return yes;
         else
            count++;
     return no;
/**/
   };   /* is_primitive()   */
/*************************************************************/
void put_into_list(char primitive_name[])
    {
      char* string;
      int   length;
/**/
      length = strlen(primitive_name);
      string = new char [length+1];
      strcpy(string,primitive_name);
      primitives[number_primitives++] = string; 
/**/
    };   /*  put_into_list()   */
/*************************************************************/
int process_line(char line[],file_chain* file_pointer)
    {
//cout << "1     Line to be processed: " << line << endl;
/**/
      int length;
      if ((strlen(line) > 0) && (is_empty_line(line) == no))
         {
//cout << "2    Line to be processed: " << line << strlen(line) << endl;
           comment_position = NULL;
           if ((is_comment_line(line) == no) &&
                      (comment_position == NULL))
              if (module_found == no)
                 {
                   module_position = NULL;
//cout << "aaaaaaaaaaaaaaa " << line << endl;

//   Insert code to check for connectmodule


                   if (((module_position = strstr(line,module))
                                              != NULL) &&
                                 (strstr(line,endmodule) == NULL))
                      {   // line with word "module" found
                         extract_module_name(line,module_name);
                         insert_module_name(file_pointer,module_name);
//at this point, module_pointer points to the module we are in
                         module_found = yes;
                      }
                   else;
               }
             else  // we are in a module now
                if ((parenth_pointer = 
                                strchr(line,opening_parenthesis))
                                                == NULL)
                   if (strstr(line,endmodule) != NULL)
// { cout << "keyword 'endmodule' encountered" << endl;
                       module_found = no; //module end reached
//}
                   else;
                else // check here for module instances
                   if (is_keyword(line) == no)
               {
//cout << "It's not a keyword =" << line << endl;
                      if (is_continuation_line(line)
                                              == no)
                         {
//cout << "Line with instantiation: " << line << endl;
                            length = extract_instance_name(line,
                                              instance_name);
                            if (length > 0)
                               {
                                  bridge_the_gap(line);
                                  length = extract_instance_source(broken_line,
                                                     line,instance_source);
                                  if (length > 0)
                                     if (strcmp(instance_source,primitive) == 0)
                                        put_into_list(instance_name);
                                     else if (is_primitive(instance_name) == no)
                                        insert(instance_name,instance_source,
                                                   module_pointer);
                                     else;// ignore instantiation of primitive
                                  else;
                               }
                            else;
                         }
                      else; //continuation line
                 }
                   else; //parenth. and keyword
        else; // it's a comment line, ignore it
     }
   else;      // line is empty, ignore it
/**/
        return error_code;
/**/
   };  /*  precess_line()  */
/*************************************************************/
    }; /* end class scan */
/*************************************************************/
/*************************************************************/
/*************************************************************/
//    cout  << "Line is = " << line << endl; 
