/************************************************************/
/************************************************************/
/************************************************************/
class erreur // French version of the word "error",
{            // English version not accepted by the compiler.
  private:
            enum anonymous
               {
                     number_error_messages = 27
               };
            char *messages[number_error_messages];
  public:
     erreur()
        {
             messages[ 0] = "Unable to determine HD language";
             messages[ 1] = "Passed parameter is not a valid file name";
             messages[ 2] = "More than one passed params have the same name";
             messages[ 3] = "This directory does not exist";
             messages[ 4] = "There is not enough memory available for accessing";
             messages[ 5] = "Attempt to access directory failed. Reboot your system";
             messages[ 6] = "Cannot read contents of directory";
             messages[ 7] = "This directory may be empty";
             messages[ 8] = "File could not be found";
             messages[ 9] = "No file name given to this directory";
             messages[10] = "This is not a valid directory name";
             messages[11] = "This is not a valid switch";
             messages[12] = "Cannot open file";
             messages[13] = "This file is empty";
             messages[14] = "A top module could not be found";
             messages[15] = "This file may not exist, please check!";
             messages[16] = "Please specify a file name!";
             messages[17] = "Please specify only one file name!";
             messages[18] = "Wrong file name and/or extension";
             messages[19] = "Only a file name and possibly comments are allowed";
             messages[20] = "The directory";
             messages[21] = "does not contain files with the extension";
             messages[22] = "Cannot find any dot in this name";
             messages[23] = "This variable cannot be found in the environment";
             messages[24] = "Can't open output file";
             messages[25] = "This is supposed to be the top module";
             messages[26] = "but it contains no instantiated modules";
        };
/*************************************************************/
     int print_error_message(int index)
       {
           cerr << "\n" << messages[index] << "\n" << endl;
           return 1;   //  1 means an error was found
       };
/*************************************************************/
     int print_error_message(int index,char argument[])
       {
         cerr << "\n"  << messages[index] << ": " << argument << "\n" << endl;
         return 1; // 1 means error
       };
/*************************************************************/
int print_error_message(int index,char argu_1[],char argu_2[])
  {
    cerr << "\n" << messages[index] << ": " << argu_1 << "\n"
         << messages[index+1] << ": " << argu_2 << "\n" << endl;  
    return 1;
  };
/*************************************************************/
}; /* end class erreur */
/*************************************************************/
/*************************************************************/
/*************************************************************/
