# ifndef generic
# define generic
/**/
char* design_list_name = "design_list.html";
char* design_tree_name = "design_tree.html";
char* design_file_name = "design.html";
/**/
    enum answers
            {
               yes,
               no,
               neither  // used only in vhdl_scanner.h
            };
/**/
    enum eponymous
            {
               line_length = 250
            };
/**/
    enum diverses
            {
               colon               = ':',
               dash                = '-',
               dollar              = '$',
               opening_parenthesis = '(',
               point               = '.',
               sharp               = '#',
               slash               = '/',
               star                = '*',
               terminator          = '\0',
               underscore          = '_',
//               v                   = 'v'
            };
/**/
char *vhd  = "vhd";
char *vhdl = "vhdl";
/**/
char *h    = "h";
/**/
char *v    = "v";
char *vg   = "vg";
char *ncv  = "ncv";
char *vlog = "vlog";
/**/
#define is_star(x)          ((x == star)           ? 1 : 0)
#define is_sharp(x)         ((x == sharp)          ? 1 : 0)
#define is_slash(x)         ((x == slash)          ? 1 : 0)
#define is_point(x)         ((x == point)          ? 1 : 0)
#define is_dollar(x)        ((x == dollar)         ? 1 : 0)
#define is_terminator(x)    ((x == terminator)     ? 1 : 0)
#define is_underscore(x)    ((x == underscore)     ? 1 : 0)
/**/
#define is_h(x)             ((strcmp(x,h)   == 0) ? 1 : 0)
/**/
#define is_vhdl(x)          ((strcmp(x,vhdl) == 0) ? 1 : 0)
#define is_vhd(x)           ((strcmp(x,vhdl) == 0) ? 1 : 0)
/**/
#define is_vihdl(x)            (((is_vhdl(x)) || \
                                (is_vhd(x))) ? 1 : 0)
/**/
/**/
/**/
#define is_v(x)             ((strcmp(x,v)    == 0) ? 1 : 0)
#define is_vg(x)            ((strcmp(x,vg)   == 0) ? 1 : 0)
#define is_ncv(x)           ((strcmp(x,ncv)  == 0) ? 1 : 0)
#define is_vlog(x)          ((strcmp(x,vlog) == 0) ? 1 : 0)
/**/
#define is_verilog(x)       ((is_v(x))   || ((is_vg(x)) || \
                             (is_ncv(x)) || (is_vlog(x))) ? 1 : 0)
/**
/**/
#define is_valid_extension(x) (((is_verilog(x)) || (is_h(x)) || \
                              (is_vhd(x))) ? 1 : 0)
/**/
#endif
