/**************************************************************/
/**************************************************************/
/**************************************************************/
class info
{
private:
    enum
       {
          number_help_lines = 30,
          number_info_lines =  4
       };
    char * version;
    char * help[number_help_lines];
    char * information[number_info_lines];
public:
    info()
      {
        version = "0.1.0";
/**/
help[ 0] = "This program will take as input a list of files that contain";
help[ 1] = "Verilog and/or VHDL code and produce a tree showing the modules";
help[ 2] = "and/or architectures that are instantiated within other modules";
help[ 3] = "and/or architectures. The root of the tree is the module that is";
help[ 4] = "not instantiated in any other module.";
help[ 6] = "It is considered an error to find more than one modules that are";
help[ 7] = "not instantiated.";
/**/
help[ 8] = "\n\nThis program can be used in two ways:";
help[ 9] = "'profile -f <file_name>'";
help[10] = "<file_name> is the name of file that contains a list of Verilog and/";
help[11] = "or VHDL files. The extensions '.v', '.vg', '.ncv', '.vlog' and";
help[12] = "'.vhd', '.vhdl' decide which language is to be processed.";
help[13] = "The extension '.h' is allowed although it is highly unlikely";
help[14] = "that someone will put 'executable' code in such a file.";
help[15] = "The files to be processed are not expected to be in the same";
help[16] = "directory. This means, paths in front of the file names are allowed.";
help[17] = "The paths are considered relative to the path that the command 'pwd'";
help[18] = "will return, not relative to the place where 'profile' is located.";
help[19] = "Empty lines and C++ - type comments are allowed within <file_name>.";
help[20] = "The wildcard character '*' may be used ";
/**/
help[24] = "\n'profile [<file_name>]'";
help[25] = "<file name> is one or more file names that contain HDL code.";
help[26] = "Again, paths are allowed in front of the file names. The same rules";
help[27] = "apply, see above.";
/**/
        information[ 0] = "Type:";
        information[ 1] = "'profile'    to get this text";
        information[ 2] = "'profile -v' for the version number.";
        information[ 3] = "'profile -h' for help on how to use\
 the program.";
      };
   ~info()
      {
      }
/**************************************************************/
void print_version()
   {
      cout << endl << endl << version << endl << endl;
/**/
   };    /*  print_version()  */
/**************************************************************/
void print_help()
{
   cout << endl << endl;
   for (int count=0; count<number_help_lines; count++)
       cout << help[count] << endl;
   cout << endl << endl;
/**/
};   /*   print_help()  */
/**************************************************************/
void print_info()
{
   cout << endl << endl;
   for (int count=0; count<number_info_lines; count++)
       cout << information[count] << endl;
   cout << endl << endl;
/**/
};   /*   print_info()  */
/**************************************************************/
};   /*  class info  */
/**************************************************************/
/**************************************************************/
/**************************************************************/

